--[[============================================================================
main.lua
============================================================================]]--

-- Reload the script whenever this file is saved. 
-- Additionally, execute the attached function.
_AUTO_RELOAD_DEBUG = function()
  
end

local song

--------------------------------------------------------------------------------
-- Main functions
--------------------------------------------------------------------------------

local function get_best_line(edit_step, cur_lin)
  --get info
  local pat_len = song.selected_pattern.number_of_lines
  --deduce best line
  local best_line
  if pat_len < edit_step then
    best_line = 1
  else
    best_line = math.floor(cur_lin/edit_step)*edit_step + 1
    --test special cases
    if best_line >= pat_len then
      --slipped into next sequence? guard
      best_line = 1
    end
  end 
  --return best line
  return best_line or 1 --the 1 is just a safequard
end

local function set_line()
  local e_step = song.transport.edit_step
  --if edit_step is something other than 0 or 1, act!
  if e_step > 1 then
    local good_pos = song.transport.edit_pos
    good_pos.line = get_best_line(e_step, good_pos.line)
    song.transport.edit_pos = good_pos
  end
end

local function evaluate_trigger()
  if song.transport.follow_player == true then
    local is_stopped = song.transport.playing == false
    if is_stopped then
      set_line()
    end
  end
end



--- the big setup
local function boot()
  song = renoise.song()
  if not song.transport.playing_observable:has_notifier(evaluate_trigger) then
    song.transport.playing_observable:add_notifier(evaluate_trigger)
  end
end
if not renoise.tool().app_new_document_observable:has_notifier(boot) then
  renoise.tool().app_new_document_observable:add_notifier(boot)
end


local function shutdown()
  if song.transport.playing_observable:has_notifier(evaluate_trigger) then
    song.transport.playing_observable:remove_notifier(evaluate_trigger)
  end
  song = nil
end
if not renoise.tool().app_release_document_observable:has_notifier(shutdown) then
  renoise.tool().app_release_document_observable:add_notifier(shutdown)
end
